searchNodes=[{"doc":"Client for Mixpanel Ingestion API. It provides a sync API that makes HTTP request to the Mixpanel API. And also a async API that buffers and delivers the buffered events to Mixpanel in background. Checkout the documentation for more information. Installation The package can be installed by adding mxpanel to your list of dependencies in mix.exs : def deps do [ { :mxpanel , &quot;~&gt; 0.1.0&quot; } , { :jason , &quot;~&gt; 1.2&quot; } , { :finch , &quot;~&gt; 0.5&quot; } ] end Usage Track event Add to your supervision tree: { Finch , name : Mxpanel.HTTPClient } Call track/2 : client = % Mxpanel.Client { token : &quot;mixpanel project token&quot; } event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;123&quot; ) Mxpanel . track ( client , event ) Enqueue an event Add to your supervision tree: { Finch , name : Mxpanel.HTTPClient } , { Mxpanel.Batcher , name : MyApp.Batcher , token : &quot;mixpanel project token&quot; } Call track_later/2 : event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;123&quot; ) Mxpanel . track_later ( MyApp.MxpanelBatcher , event ) The event will be buffered, and later sent in batch to the Mixpanel API. Telemetry Mxpanel currently exposes following Telemetry events: [:mxpanel, :batcher, :buffers_info] - Dispatched periodically by each running batcher exposing the size of each running buffer in the pool. Measurement: %{} Metadata: %{batcher_name: atom(), buffer_sizes: [integer()]} Changelog See the changelog .","ref":"Mxpanel.html","title":"Mxpanel","type":"module"},{"doc":"Returns the configured JSON encoding library for Mxpnale (defaults to Jason). To customize the JSON library, including the following in your config/config.exs: config :mxpanel , :json_library , Jason","ref":"Mxpanel.html#json_library/0","title":"Mxpanel.json_library/0","type":"function"},{"doc":"Send a single event into Mixpanel. client = % Mxpanel.Client { token : &quot;mixpanel project token&quot; } event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;123&quot; ) Mxpanel . track ( client , event )","ref":"Mxpanel.html#track/2","title":"Mxpanel.track/2","type":"function"},{"doc":"Enqueues the event. The event will be store in a buffer and sent in batches to mixpanel. Mxpanel.Batcher . start_link ( name : MyApp.MxpanelBatcher , token : &quot;mixpanel project token&quot; ) event = Mxpanel.Event . new ( &quot;signup&quot; , &quot;123&quot; ) Mxpanel . track_later ( MyApp.MxpanelBatcher , event ) Why use it? HTTP requests to the Mixpanel API often take time and may fail. If you are tracking events during a web request, you probably, don't want to make your users wait the extra time for the mixpanel API call to finish. Checkout Mxpanel.Batcher for more information.","ref":"Mxpanel.html#track_later/2","title":"Mxpanel.track_later/2","type":"function"},{"doc":"Import a batch of events into Mixpanel. client = % Mxpanel.Client { token : &quot;mixpanel project token&quot; } event_1 = Mxpanel.Event . new ( &quot;signup&quot; , &quot;123&quot; ) event_2 = Mxpanel.Event . new ( &quot;signup&quot; , &quot;456&quot; ) Mxpanel . track ( client , [ event_1 , event_2 ] )","ref":"Mxpanel.html#track_many/2","title":"Mxpanel.track_many/2","type":"function"},{"doc":"Manages a pool of buffers that accumulate the events and sends them to the Mixpanel API in batches in background. It implements a registry-based routing pool with round-robing as routing strategy. Checkout start_link/1 for all supported options. Usage Add to your supervision tree: { Finch , name : Mxpanel.HTTPClient } , { Mxpanel.Batcher , name : MyApp.Batcher , token : &quot;mixpanel project token&quot; } Enqueue an event: Mxpanel . track_later ( MyApp.MxpanelBatcher , event ) The event will be buffered, and later sent in batch to the Mixpanel API.","ref":"Mxpanel.Batcher.html","title":"Mxpanel.Batcher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mxpanel.Batcher.html#child_spec/1","title":"Mxpanel.Batcher.child_spec/1","type":"function"},{"doc":"Starts a Mxpanel.Batcher linked to the current process. Supported options :name - Required. Name of the batcher instance. :token - Required. The Mixpanel token associated with your project. :base_url - Mixpanel API URL The default value is &quot;https://api.mixpanel.com&quot; . :http_client - HTTP client used by the Batcher The default value is {Mxpanel.HTTPClient.FinchAdapter, [name: Mxpanel.HTTPClient]} . :pool_size - The size of the pool of event buffers. The default value is 10 . :flush_interval - Interval in milliseconds which the event buffer are processed. The default value is 5000 . :flush_jitter - Jitter the flush interval by a random amount. Value in milliseconds. This is primarily to avoid large write spikes. For example, a flush_jitter of 1s and flush_interval of 1s means flushes will happen every 5-6s. The default value is 1000 . :retry_max_attempts - Max attempts that a batch of events should be tried before giving up. The default value is 3 . :retry_base_backoff - Base time in milliseconds to calculate the wait time between retry attempts. Formula: (attempt * retry_base_backoff) + random(1..retry_base_backoff) . The default value is 100 . :import_timeout - The maximum amount of time in milliseconds each batch of events is allowed to execute for. The default value is 30000 . :telemetry_buffers_info_interval - Interval in milliseconds the telemetry with the buffers info is published. The default value is 30000 .","ref":"Mxpanel.Batcher.html#start_link/1","title":"Mxpanel.Batcher.start_link/1","type":"function"},{"doc":"","ref":"Mxpanel.Batcher.html#t:name/0","title":"Mxpanel.Batcher.name/0","type":"type"},{"doc":"Struct representing a Mxpanel Client. Default Usage % Mxpanel.Client { token : &quot;project_token&quot; } EU API % Mxpanel.Client { token : &quot;project_token&quot; , base_url : &quot;api-eu.mixpanel.com&quot; } Custom HTTP client You can switch the default HTTP client which uses finch underneath by defining a different implementation by setting the :http_client option: % Mxpanel.Client { http_client : { MyCustomHTTPClient , [ ] } , token : &quot;token&quot; }","ref":"Mxpanel.Client.html","title":"Mxpanel.Client","type":"module"},{"doc":"","ref":"Mxpanel.Client.html#t:t/0","title":"Mxpanel.Client.t/0","type":"type"},{"doc":"Struct representing a Mixpanel Event","ref":"Mxpanel.Event.html","title":"Mxpanel.Event","type":"module"},{"doc":"Create a new event. Mxpanel.Event . new ( &quot;signup&quot; , &quot;13793&quot; , %{ &quot;Favourite Color&quot; =&gt; &quot;Red&quot; } )","ref":"Mxpanel.Event.html#new/3","title":"Mxpanel.Event.new/3","type":"function"},{"doc":"Serialize a event into the format expected by the Mixpanel API.","ref":"Mxpanel.Event.html#serialize/2","title":"Mxpanel.Event.serialize/2","type":"function"},{"doc":"","ref":"Mxpanel.Event.html#t:t/0","title":"Mxpanel.Event.t/0","type":"type"},{"doc":"Specifies the behaviour of a HTTP Client.","ref":"Mxpanel.HTTPClient.html","title":"Mxpanel.HTTPClient","type":"behaviour"},{"doc":"Sends an HTTP request.","ref":"Mxpanel.HTTPClient.html#c:request/5","title":"Mxpanel.HTTPClient.request/5","type":"callback"},{"doc":"Adapter for finch . Remember to add {:finch, &quot;~&gt; 0.5&quot;} to dependencies. Also, you need to recompile mxpanel after adding the :finch dependency: mix deps . clean mxpanel mix compile Usage Add to your supervision tree: { Finch , name : Mxpanel.HTTPClient } Finch is already the default adapter: % Mxpanel.Client { token : &quot;token&quot; }","ref":"Mxpanel.HTTPClient.FinchAdapter.html","title":"Mxpanel.HTTPClient.FinchAdapter","type":"module"},{"doc":"","ref":"Mxpanel.HTTPClient.FinchAdapter.html#pop!/2","title":"Mxpanel.HTTPClient.FinchAdapter.pop!/2","type":"function"},{"doc":"Adapter for hackney . Remember to add {:hackney, &quot;~&gt; 1.17&quot;} to dependencies. Also, you need to recompile mxpanel after adding the :hackney dependency: mix deps . clean mxpanel mix compile Usage %Mxpanel.Client{http_client: {Mxpanel.HTTPClient.HackneyAdapter, []}, token: &quot;token&quot;}","ref":"Mxpanel.HTTPClient.HackneyAdapter.html","title":"Mxpanel.HTTPClient.HackneyAdapter","type":"module"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Added Add track/2 . Add track_many/2 . Add track_later/2 .","ref":"changelog.html#0-1-0-2021-06-16","title":"Changelog - 0.1.0 - 2021-06-16","type":"extras"}]